■カルテ1用のEntryDetailsテーブル、OrderDetailsテーブルを作成
CREATE TABLE EntryDetails
( entry_id   CHAR(3) NOT NULL,
  entry_seq  INTEGER NOT NULL,
  item		 CHAR(3) ,
  quantity   INTEGER ,
  PRIMARY KEY (entry_id, entry_seq));


CREATE TABLE OrderDetails
( order_id   CHAR(3) NOT NULL,
  order_seq  INTEGER NOT NULL,
  entry_id   CHAR(3) NOT NULL,
  entry_seq  INTEGER NOT NULL,
  item		 CHAR(3) ,
  quantity   INTEGER ,
  PRIMARY KEY (order_id, order_seq));

DELETE FROM EntryDetails;
INSERT INTO EntryDetails VALUES ('001', 1, 'DK0', 1);
INSERT INTO EntryDetails VALUES ('001', 2, 'CF2', 3);
INSERT INTO EntryDetails VALUES ('001', 3, 'AA9', 2);
INSERT INTO EntryDetails VALUES ('002', 1, 'BF8', 10);
INSERT INTO EntryDetails VALUES ('002', 2, 'CF2', 1);
INSERT INTO EntryDetails VALUES ('003', 1, 'DK0', 5);

DELETE FROM OrderDetails;
INSERT INTO OrderDetails VALUES ('OD1', 1, '001', 1, NULL, NULL);
INSERT INTO OrderDetails VALUES ('OD1', 2, '001', 2, NULL, NULL);
INSERT INTO OrderDetails VALUES ('OD1', 3, '001', 3, NULL, NULL);
INSERT INTO OrderDetails VALUES ('OD2', 1, '002', 1, NULL, NULL);
INSERT INTO OrderDetails VALUES ('OD2', 2, '002', 2, NULL, NULL);
INSERT INTO OrderDetails VALUES ('OD3', 1, '003', 1, NULL, NULL);

■リスト1
UPDATE OrderDetails
   SET item     = (SELECT item 
                     FROM EntryDetails AS ED
                    WHERE OrderDetails.entry_id  = ED.entry_id
                      AND OrderDetails.entry_seq = ED.entry_seq),
       quantity = (SELECT quantity
                     FROM EntryDetails AS ED
                    WHERE OrderDetails.entry_id  = ED.entry_id
                      AND OrderDetails.entry_seq = ED.entry_seq);

■リスト2
UPDATE OrderDetails
   SET (item, quantity)
           = (SELECT item, quantity
                     FROM EntryDetails ED
                    WHERE OrderDetails.entry_id  = ED.entry_id
                      AND OrderDetails.entry_seq = ED.entry_seq);


■カルテ2用のEntryDetailsテーブル、OrderDetailsを作成
DELETE FROM EntryDetails;
INSERT INTO EntryDetails VALUES ('001', 1, 'DK0', 1);
INSERT INTO EntryDetails VALUES ('001', 2, 'CF2', 3);
INSERT INTO EntryDetails VALUES ('002', 1, 'BF8', 10);
INSERT INTO EntryDetails VALUES ('003', 1, 'DK0', 5);

DELETE FROM OrderDetails;
INSERT INTO OrderDetails VALUES ('OD1', 1, '001', 1, NULL, NULL);
INSERT INTO OrderDetails VALUES ('OD1', 2, '001', 2, NULL, NULL);
INSERT INTO OrderDetails VALUES ('OD1', 3, '001', 3, NULL, NULL);
INSERT INTO OrderDetails VALUES ('OD2', 1, '002', 1, NULL, NULL);
INSERT INTO OrderDetails VALUES ('OD2', 2, '002', 2, NULL, NULL);
INSERT INTO OrderDetails VALUES ('OD3', 1, '003', 1, NULL, NULL);

■リスト3
--更新対象を制限する
UPDATE OrderDetails
   SET (item, quantity)
           = (SELECT item, quantity
                     FROM EntryDetails ED
                    WHERE OrderDetails.entry_id  = ED.entry_id
                      AND OrderDetails.entry_seq = ED.entry_seq)
 WHERE EXISTS (SELECT *
                 FROM EntryDetails ED
                WHERE OrderDetails.entry_id  = ED.entry_id
                  AND OrderDetails.entry_seq = ED.entry_seq);


■Hotelテーブルの作成
DROP TABLE Hotel;
CREATE TABLE Hotel
( floor_nbr INTEGER     NOT NULL,
  room_nbr  INTEGER     );

DELETE FROM Hotel;
INSERT INTO Hotel VALUES (1, NULL);
INSERT INTO Hotel VALUES (1, NULL);
INSERT INTO Hotel VALUES (1, NULL);
INSERT INTO Hotel VALUES (2, NULL);
INSERT INTO Hotel VALUES (2, NULL);
INSERT INTO Hotel VALUES (3, NULL);
INSERT INTO Hotel VALUES (3, NULL);

■リスト4
--DB2のみの技
UPDATE Hotel
   SET room_nbr = (floor_nbr * 100)
                    + ROW_NUMBER() OVER (PARTITION BY floor_nbr);

■客室番号に連番が付いたHotel_2テーブルを作成
DROP TABLE Hotel_2;
CREATE TABLE Hotel_2
( floor_nbr INTEGER     NOT NULL,
  room_nbr  INTEGER     ,
  PRIMARY KEY (floor_nbr, room_nbr));

DELETE FROM Hotel_2;
INSERT INTO Hotel_2 VALUES(1, (SELECT COALESCE(MAX(room_nbr), 0) +1 FROM Hotel_2));
INSERT INTO Hotel_2 VALUES(1, (SELECT COALESCE(MAX(room_nbr), 0) +1 FROM Hotel_2));
INSERT INTO Hotel_2 VALUES(1, (SELECT COALESCE(MAX(room_nbr), 0) +1 FROM Hotel_2));
INSERT INTO Hotel_2 VALUES(2, (SELECT COALESCE(MAX(room_nbr), 0) +1 FROM Hotel_2));
INSERT INTO Hotel_2 VALUES(2, (SELECT COALESCE(MAX(room_nbr), 0) +1 FROM Hotel_2));
INSERT INTO Hotel_2 VALUES(3, (SELECT COALESCE(MAX(room_nbr), 0) +1 FROM Hotel_2));
INSERT INTO Hotel_2 VALUES(3, (SELECT COALESCE(MAX(room_nbr), 0) +1 FROM Hotel_2));

■リスト5
UPDATE Hotel_2
   SET room_nbr
         =  (SELECT nbr
               FROM (SELECT room_nbr, 
                           (floor_nbr * 100) +
                              ROW_NUMBER() OVER(PARTITION BY floor_nbr
                                           ORDER BY room_nbr) AS nbr
                       FROM Hotel_2) TMP
              WHERE Hotel_2.room_nbr = TMP.room_nbr);


